import{s as Gn,f as Ae,n as Dn,o as Jn}from"../chunks/scheduler.f6b352c8.js";import{S as Rn,i as zn,g as o,s as l,r as f,A as On,h as a,f as n,c as s,j as Bn,u as m,x as r,k as u,y as Nn,a as i,v as g,d as h,t as p,w as d}from"../chunks/index.7f38e934.js";import{H as c}from"../chunks/Heading.333929c4.js";import{E as Xn}from"../chunks/EditOnGithub.c3245a01.js";function Yn(Rt){let w,ke,Me,Ie,x,je,L,zt='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/thumbnail.jpg" alt="AI Agents Course thumbnail" width="100%"/> <figcaption>The background of the image was generated using <a href="https://scenario.gg/">Scenario.gg</a></figcaption>',qe,C,Ot="Welcome to the most exciting topic in AI today: <strong>Agents</strong>!",Ue,H,Nt="This free course will take you on a journey, <strong>from beginner to expert</strong>, in understanding, using and building AI agents.",Fe,_,Xt="This first unit will help you onboard:",Se,M,Yt="<li>Discover the <strong>course’s syllabus</strong>.</li> <li><strong>Choose the path</strong> you’re going to take (either self-audit or certification process).</li> <li><strong>Get more information about the certification process and the deadlines</strong>.</li> <li>Get to know the team behind the course.</li> <li>Create your <strong>Hugging Face account</strong>.</li> <li><strong>Sign-up to our Discord server</strong>, and meet your classmates and us.</li>",We,P,Qt="Let’s get started!",Ee,A,Be,k,Vt="In this course, you will:",Ge,I,Kt='<li>📖 Study AI Agents in <strong>theory, design, and practice.</strong></li> <li>🧑‍💻 Learn to <strong>use established AI Agent libraries</strong> such as <a href="https://huggingface.co/docs/smolagents/en/index" rel="nofollow">smolagents</a>, <a href="https://www.langchain.com/" rel="nofollow">LangChain</a>, and <a href="https://www.llamaindex.ai/" rel="nofollow">LlamaIndex</a>.</li> <li>💾 <strong>Share your agents</strong> on the Hugging Face Hub and explore agents created by the community.</li> <li>🏆 Participate in challenges where you will <strong>evaluate your agents against other students’.</strong></li> <li>🎓 <strong>Earn a certificate of completion</strong> by completing assignments.</li>',De,j,Zt="And more!",Je,q,en="At the end of this course you’ll understand <strong>how Agents work and how to build your own Agents using the latest libraries and tools</strong>.",Re,U,tn='Don’t forget to <strong><a href="https://bit.ly/hf-learn-agents">sign up to the course!</a></strong> (We are respectful of your privacy. We collect your email address to be able to <strong>send you the links when each Unit is published and give you information about the challenges and updates).</strong>',ze,F,nn='Sign up  👉 <a href="https://bit.ly/hf-learn-agents">here</a>',Oe,S,Ne,W,ln="The course is composed of:",Xe,E,sn='<li><em>Foundational Units</em>: where you learn Agents <strong>concepts in theory</strong>.</li> <li><em>Hands-on</em>: where you’ll learn <strong>to use established AI Agent libraries</strong> to train your agents in unique environments. These hands-on sections will be <strong>Hugging Face Spaces</strong> with a pre-configured environment!</li> <li><em>Use case assignments</em>: where you’ll apply the concepts you’ve learned to solve a real-world problem that you’ll choose.</li> <li><em>The Challenge</em>: you’ll get to put your agent to compete against other agents in a challenge. There will also be <a href="https://huggingface.co/spaces/huggingface-projects/AI-Agents-Leaderboard" rel="nofollow">a leaderboard</a> for you to compare the agents’ performance.</li>',Ye,B,on='This course is a living project, evolving with your feedback and contributions! Feel free to <a href="https://github.com/huggingface/agents-course" rel="nofollow">open issues and PRs in GitHub</a>, and engage in discussions in our Discord server.',Qe,G,an='After you have gone through the course, you can also send your feedback  <a href="https://docs.google.com/forms/d/e/1FAIpQLSe9VaONn0eglax0uTwi29rIn4tM7H2sYmmybmG5jJNlE5v0xA/viewform?usp=dialog" rel="nofollow">👉 using this form</a>',Ve,D,Ke,J,rn="Here is the general syllabus for the course. A more detailed list of topics will be released with each unit.",Ze,R,un='<thead><tr><th align="left">Chapter</th> <th align="left">Topic</th> <th align="left">Description</th></tr></thead> <tbody><tr><td align="left">0</td> <td align="left">Onboarding</td> <td align="left">Set you up with the tools and platforms that you will use.</td></tr> <tr><td align="left">1</td> <td align="left">Agent Fundamentals</td> <td align="left">Explain Tools, Thoughts, Actions, Observations, and their formats. Explain LLMs, messages, special tokens and chat templates. Show a simple use case using python functions as tools.</td></tr> <tr><td align="left">2</td> <td align="left">Frameworks</td> <td align="left">Understand how the fundamentals are implemented in popular libraries : smolagents, LangGraph, LLamaIndex</td></tr> <tr><td align="left">3</td> <td align="left">Use Cases</td> <td align="left">Let’s build some real life use cases ( open to PRs 🤗 from experienced Agent builders )</td></tr> <tr><td align="left">4</td> <td align="left">Final Assignment</td> <td align="left">Build an agent for a selected benchmark and prove your understanding of Agents on the student leaderboard  🚀</td></tr></tbody>',et,z,fn="<em>We are also planning to release some bonus units, stay tuned!</em>",tt,O,nt,N,mn="To be able to follow this course you should have a:",it,X,gn="<li>Basic knowledge of Python</li> <li>Basic knowledge of LLMs (we have a section in Unit 1 to recap what they are)</li>",lt,Y,st,Q,hn="You only need 2 things:",ot,V,pn='<li><em>A computer</em> with an internet connection.</li> <li>A <em>Hugging Face Account</em>: to push and load models, agents, and create Spaces. If you don’t have an account yet, you can create one <strong><a href="https://hf.co/join" rel="nofollow">here</a></strong> (it’s free).<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/tools.jpg" alt="Course tools needed" width="100%"/></li>',at,K,rt,v,dn,ut,Z,cn="You can choose to follow this course <em>in audit mode</em>, or do the activities and <em>get one of the two certificates we’ll issue</em>.",ft,ee,wn="If you audit the course, you can participate in all the challenges and do assignments if you want, and <em>you don’t need to notify us</em>.",mt,te,vn="The certification process is <strong>completely free</strong>:",gt,ne,$n="<li><em>To get a certification for fundamentals</em>: you need to complete Unit 1 of the course. This is intended for students that want to get up to date with the latest trends in Agents.</li> <li><em>To get a certificate of completion</em>: you need to complete Unit 1, one of the use case assignments we’ll propose during the course, and the final challenge.</li>",ht,ie,yn="There’s a deadline for the certification process: all the assignments must be finished before <strong>May 1st 2025</strong>.",pt,$,Tn,dt,le,ct,se,bn="Each chapter in this course is designed <strong>to be completed in 1 week, with approximately 3-4 hours of work per week</strong>.",wt,oe,xn="Since there’s a deadline, we provide you a recommended pace:",vt,y,Ln,$t,ae,yt,re,Cn="To get the most out of the course, we have some advice:",Tt,ue,Hn='<li><a href="https://discord.gg/UrrTSsSyjb">**Join study groups in Discord**</a>: studying in groups is always easier. To do that, you need to join our discord server and verify your Hugging Face account.</li> <li><strong>Do the quizzes and assignments</strong>: the best way to learn is through hands-on practice and self-assessment..</li> <li><strong>Define a schedule to stay in sync</strong>: you can use our recommended pace schedule below or create yours.</li>',bt,T,_n,xt,fe,Lt,me,Mn="About the authors:",Ct,ge,Ht,he,Pn="Joffrey is a machine learning engineer at Hugging Face and has built and deployed AI Agents in production. Joffrey will be your main instructor for this course.",_t,pe,An='<li><a href="https://x.com/Jthmas404" rel="nofollow">Follow Joffrey on X</a></li> <li><a href="https://www.linkedin.com/in/joffrey-thomas/" rel="nofollow">Follow Joffrey on Linkedin</a></li>',Mt,de,Pt,ce,kn="Ben is a machine learning engineer at Hugging Face and has delivered multiple courses across various platforms. Ben’s goal is to make the course accessible to everyone.",At,we,In='<li><a href="https://x.com/ben_burtenshaw" rel="nofollow">Follow Ben on X</a></li> <li><a href="https://www.linkedin.com/in/ben-burtenshaw/" rel="nofollow">Follow Ben on Linkedin</a></li>',kt,ve,It,$e,jn='Thomas is a machine learning engineer at Hugging Face and delivered the successful <a href="https://huggingface.co/learn/deep-rl-course/unit0/introduction">Deep RL</a> and <a href="https://huggingface.co/learn/ml-games-course/en/unit0/introduction">ML for games</a> courses. Thomas is a big fan of Agents and is excited to see what the community will build.',jt,ye,qn='<li><a href="https://x.com/ThomasSimonini" rel="nofollow">Follow Thomas on X</a></li> <li><a href="https://www.linkedin.com/in/simoninithomas/" rel="nofollow">Follow Thomas on Linkedin</a></li>',qt,Te,Ut,be,Un="Contributions are <strong>welcome</strong> 🤗",Ft,xe,Fn='<li>If you <em>found a bug 🐛 in a notebook</em>, please <a href="https://github.com/huggingface/agents-course/issues">open an issue</a> and <strong>describe the problem</strong>.</li> <li>If you <em>want to improve the course</em>, you can <a href="https://github.com/huggingface/agents-course/pulls">open a Pull Request.</a></li> <li>If you <em>want to add a full section or a new unit</em>, the best is to <a href="https://github.com/huggingface/agents-course/issues">open an issue</a> and <strong>describe what content you want to add before starting to write it so that we can guide you</strong>.</li>',St,Le,Wt,Ce,Sn='Please ask your question in our <a href="https://discord.gg/UrrTSsSyjb">discord server #ai-agents-discussions.</a>',Et,He,Wn="Now that you have all the information, let’s get on board ⛵",Bt,b,En,Gt,_e,Dt,Pe,Jt;return x=new c({props:{title:"Welcome to the 🤗 AI Agents Course",local:"introduction",headingTag:"h1"}}),A=new c({props:{title:"What to expect from this course?",local:"expect",headingTag:"h2"}}),S=new c({props:{title:"What does the course look like?",local:"course-look-like",headingTag:"h2"}}),D=new c({props:{title:"What’s the syllabus?",local:"syllabus",headingTag:"h2"}}),O=new c({props:{title:"What are the prerequisites?",local:"what-are-the-prerequisites",headingTag:"h2"}}),Y=new c({props:{title:"What tools do I need?",local:"tools",headingTag:"h2"}}),K=new c({props:{title:"The Certification Process",local:"certification-process",headingTag:"h2"}}),le=new c({props:{title:"What is the recommended pace?",local:"recommended-pace",headingTag:"h2"}}),ae=new c({props:{title:"How to get the most out of the course?",local:"advice",headingTag:"h2"}}),fe=new c({props:{title:"Who are we",local:"who-are-we",headingTag:"h2"}}),ge=new c({props:{title:"Joffrey Thomas",local:"joffrey-thomas",headingTag:"h3"}}),de=new c({props:{title:"Ben Burtenshaw",local:"ben-burtenshaw",headingTag:"h3"}}),ve=new c({props:{title:"Thomas Simonini",local:"thomas-simonini",headingTag:"h3"}}),Te=new c({props:{title:"I found a bug, or I want to improve the course",local:"contribute",headingTag:"h2"}}),Le=new c({props:{title:"I still have questions",local:"questions",headingTag:"h2"}}),_e=new Xn({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit0/introduction.mdx"}}),{c(){w=o("meta"),ke=l(),Me=o("p"),Ie=l(),f(x.$$.fragment),je=l(),L=o("figure"),L.innerHTML=zt,qe=l(),C=o("p"),C.innerHTML=Ot,Ue=l(),H=o("p"),H.innerHTML=Nt,Fe=l(),_=o("p"),_.textContent=Xt,Se=l(),M=o("ul"),M.innerHTML=Yt,We=l(),P=o("p"),P.textContent=Qt,Ee=l(),f(A.$$.fragment),Be=l(),k=o("p"),k.textContent=Vt,Ge=l(),I=o("ul"),I.innerHTML=Kt,De=l(),j=o("p"),j.textContent=Zt,Je=l(),q=o("p"),q.innerHTML=en,Re=l(),U=o("p"),U.innerHTML=tn,ze=l(),F=o("p"),F.innerHTML=nn,Oe=l(),f(S.$$.fragment),Ne=l(),W=o("p"),W.textContent=ln,Xe=l(),E=o("ul"),E.innerHTML=sn,Ye=l(),B=o("p"),B.innerHTML=on,Qe=l(),G=o("p"),G.innerHTML=an,Ve=l(),f(D.$$.fragment),Ke=l(),J=o("p"),J.textContent=rn,Ze=l(),R=o("table"),R.innerHTML=un,et=l(),z=o("p"),z.innerHTML=fn,tt=l(),f(O.$$.fragment),nt=l(),N=o("p"),N.textContent=mn,it=l(),X=o("ul"),X.innerHTML=gn,lt=l(),f(Y.$$.fragment),st=l(),Q=o("p"),Q.textContent=hn,ot=l(),V=o("ul"),V.innerHTML=pn,at=l(),f(K.$$.fragment),rt=l(),v=o("img"),ut=l(),Z=o("p"),Z.innerHTML=cn,ft=l(),ee=o("p"),ee.innerHTML=wn,mt=l(),te=o("p"),te.innerHTML=vn,gt=l(),ne=o("ul"),ne.innerHTML=$n,ht=l(),ie=o("p"),ie.innerHTML=yn,pt=l(),$=o("img"),dt=l(),f(le.$$.fragment),ct=l(),se=o("p"),se.innerHTML=bn,wt=l(),oe=o("p"),oe.textContent=xn,vt=l(),y=o("img"),$t=l(),f(ae.$$.fragment),yt=l(),re=o("p"),re.textContent=Cn,Tt=l(),ue=o("ol"),ue.innerHTML=Hn,bt=l(),T=o("img"),xt=l(),f(fe.$$.fragment),Lt=l(),me=o("p"),me.textContent=Mn,Ct=l(),f(ge.$$.fragment),Ht=l(),he=o("p"),he.textContent=Pn,_t=l(),pe=o("ul"),pe.innerHTML=An,Mt=l(),f(de.$$.fragment),Pt=l(),ce=o("p"),ce.textContent=kn,At=l(),we=o("ul"),we.innerHTML=In,kt=l(),f(ve.$$.fragment),It=l(),$e=o("p"),$e.innerHTML=jn,jt=l(),ye=o("ul"),ye.innerHTML=qn,qt=l(),f(Te.$$.fragment),Ut=l(),be=o("p"),be.innerHTML=Un,Ft=l(),xe=o("ul"),xe.innerHTML=Fn,St=l(),f(Le.$$.fragment),Wt=l(),Ce=o("p"),Ce.innerHTML=Sn,Et=l(),He=o("p"),He.textContent=Wn,Bt=l(),b=o("img"),Gt=l(),f(_e.$$.fragment),Dt=l(),Pe=o("p"),this.h()},l(e){const t=On("svelte-u9bgzb",document.head);w=a(t,"META",{name:!0,content:!0}),t.forEach(n),ke=s(e),Me=a(e,"P",{}),Bn(Me).forEach(n),Ie=s(e),m(x.$$.fragment,e),je=s(e),L=a(e,"FIGURE",{"data-svelte-h":!0}),r(L)!=="svelte-1vywuxn"&&(L.innerHTML=zt),qe=s(e),C=a(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-17pu5cl"&&(C.innerHTML=Ot),Ue=s(e),H=a(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-dvnpj7"&&(H.innerHTML=Nt),Fe=s(e),_=a(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1csi7fx"&&(_.textContent=Xt),Se=s(e),M=a(e,"UL",{"data-svelte-h":!0}),r(M)!=="svelte-ixjw75"&&(M.innerHTML=Yt),We=s(e),P=a(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-4b3xjd"&&(P.textContent=Qt),Ee=s(e),m(A.$$.fragment,e),Be=s(e),k=a(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-f2qxb3"&&(k.textContent=Vt),Ge=s(e),I=a(e,"UL",{"data-svelte-h":!0}),r(I)!=="svelte-dt96yw"&&(I.innerHTML=Kt),De=s(e),j=a(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-t67g99"&&(j.textContent=Zt),Je=s(e),q=a(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-rxvjyt"&&(q.innerHTML=en),Re=s(e),U=a(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1hpndln"&&(U.innerHTML=tn),ze=s(e),F=a(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1ts9z99"&&(F.innerHTML=nn),Oe=s(e),m(S.$$.fragment,e),Ne=s(e),W=a(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-1ee6w8b"&&(W.textContent=ln),Xe=s(e),E=a(e,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-x3w5er"&&(E.innerHTML=sn),Ye=s(e),B=a(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-nsgtme"&&(B.innerHTML=on),Qe=s(e),G=a(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-16fokxm"&&(G.innerHTML=an),Ve=s(e),m(D.$$.fragment,e),Ke=s(e),J=a(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-3i0qpv"&&(J.textContent=rn),Ze=s(e),R=a(e,"TABLE",{"data-svelte-h":!0}),r(R)!=="svelte-1gw18fw"&&(R.innerHTML=un),et=s(e),z=a(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1aqi5y9"&&(z.innerHTML=fn),tt=s(e),m(O.$$.fragment,e),nt=s(e),N=a(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-kqo70s"&&(N.textContent=mn),it=s(e),X=a(e,"UL",{"data-svelte-h":!0}),r(X)!=="svelte-1o8em9l"&&(X.innerHTML=gn),lt=s(e),m(Y.$$.fragment,e),st=s(e),Q=a(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-17wttjy"&&(Q.textContent=hn),ot=s(e),V=a(e,"UL",{"data-svelte-h":!0}),r(V)!=="svelte-l2nc5g"&&(V.innerHTML=pn),at=s(e),m(K.$$.fragment,e),rt=s(e),v=a(e,"IMG",{src:!0,alt:!0,width:!0}),ut=s(e),Z=a(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-knl2ed"&&(Z.innerHTML=cn),ft=s(e),ee=a(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-1yq1460"&&(ee.innerHTML=wn),mt=s(e),te=a(e,"P",{"data-svelte-h":!0}),r(te)!=="svelte-1ybbpoz"&&(te.innerHTML=vn),gt=s(e),ne=a(e,"UL",{"data-svelte-h":!0}),r(ne)!=="svelte-1mkaw8h"&&(ne.innerHTML=$n),ht=s(e),ie=a(e,"P",{"data-svelte-h":!0}),r(ie)!=="svelte-1roe7pg"&&(ie.innerHTML=yn),pt=s(e),$=a(e,"IMG",{src:!0,alt:!0,width:!0}),dt=s(e),m(le.$$.fragment,e),ct=s(e),se=a(e,"P",{"data-svelte-h":!0}),r(se)!=="svelte-16x0fhq"&&(se.innerHTML=bn),wt=s(e),oe=a(e,"P",{"data-svelte-h":!0}),r(oe)!=="svelte-1emjga4"&&(oe.textContent=xn),vt=s(e),y=a(e,"IMG",{src:!0,alt:!0,width:!0}),$t=s(e),m(ae.$$.fragment,e),yt=s(e),re=a(e,"P",{"data-svelte-h":!0}),r(re)!=="svelte-822ilm"&&(re.textContent=Cn),Tt=s(e),ue=a(e,"OL",{"data-svelte-h":!0}),r(ue)!=="svelte-elfnl2"&&(ue.innerHTML=Hn),bt=s(e),T=a(e,"IMG",{src:!0,alt:!0,width:!0}),xt=s(e),m(fe.$$.fragment,e),Lt=s(e),me=a(e,"P",{"data-svelte-h":!0}),r(me)!=="svelte-1qyo5w8"&&(me.textContent=Mn),Ct=s(e),m(ge.$$.fragment,e),Ht=s(e),he=a(e,"P",{"data-svelte-h":!0}),r(he)!=="svelte-jk5ik2"&&(he.textContent=Pn),_t=s(e),pe=a(e,"UL",{"data-svelte-h":!0}),r(pe)!=="svelte-1u6zw05"&&(pe.innerHTML=An),Mt=s(e),m(de.$$.fragment,e),Pt=s(e),ce=a(e,"P",{"data-svelte-h":!0}),r(ce)!=="svelte-yjqhaj"&&(ce.textContent=kn),At=s(e),we=a(e,"UL",{"data-svelte-h":!0}),r(we)!=="svelte-fachn0"&&(we.innerHTML=In),kt=s(e),m(ve.$$.fragment,e),It=s(e),$e=a(e,"P",{"data-svelte-h":!0}),r($e)!=="svelte-10mjr36"&&($e.innerHTML=jn),jt=s(e),ye=a(e,"UL",{"data-svelte-h":!0}),r(ye)!=="svelte-fw4318"&&(ye.innerHTML=qn),qt=s(e),m(Te.$$.fragment,e),Ut=s(e),be=a(e,"P",{"data-svelte-h":!0}),r(be)!=="svelte-nxego7"&&(be.innerHTML=Un),Ft=s(e),xe=a(e,"UL",{"data-svelte-h":!0}),r(xe)!=="svelte-1lujafl"&&(xe.innerHTML=Fn),St=s(e),m(Le.$$.fragment,e),Wt=s(e),Ce=a(e,"P",{"data-svelte-h":!0}),r(Ce)!=="svelte-1qqh474"&&(Ce.innerHTML=Sn),Et=s(e),He=a(e,"P",{"data-svelte-h":!0}),r(He)!=="svelte-gbc6aj"&&(He.textContent=Wn),Bt=s(e),b=a(e,"IMG",{src:!0,alt:!0,width:!0}),Gt=s(e),m(_e.$$.fragment,e),Dt=s(e),Pe=a(e,"P",{}),Bn(Pe).forEach(n),this.h()},h(){u(w,"name","hf:doc:metadata"),u(w,"content",Qn),Ae(v.src,dn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/three-paths.jpg")||u(v,"src",dn),u(v,"alt","Two paths"),u(v,"width","100%"),Ae($.src,Tn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/deadline.jpg")||u($,"src",Tn),u($,"alt","Deadline"),u($,"width","100%"),Ae(y.src,Ln="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/recommended-pace.jpg")||u(y,"src",Ln),u(y,"alt","Recommended Pace"),u(y,"width","100%"),Ae(T.src,_n="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/advice.jpg")||u(T,"src",_n),u(T,"alt","Course advice"),u(T,"width","100%"),Ae(b.src,En="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit0/time-to-onboard.jpg")||u(b,"src",En),u(b,"alt","Time to Onboard"),u(b,"width","100%")},m(e,t){Nn(document.head,w),i(e,ke,t),i(e,Me,t),i(e,Ie,t),g(x,e,t),i(e,je,t),i(e,L,t),i(e,qe,t),i(e,C,t),i(e,Ue,t),i(e,H,t),i(e,Fe,t),i(e,_,t),i(e,Se,t),i(e,M,t),i(e,We,t),i(e,P,t),i(e,Ee,t),g(A,e,t),i(e,Be,t),i(e,k,t),i(e,Ge,t),i(e,I,t),i(e,De,t),i(e,j,t),i(e,Je,t),i(e,q,t),i(e,Re,t),i(e,U,t),i(e,ze,t),i(e,F,t),i(e,Oe,t),g(S,e,t),i(e,Ne,t),i(e,W,t),i(e,Xe,t),i(e,E,t),i(e,Ye,t),i(e,B,t),i(e,Qe,t),i(e,G,t),i(e,Ve,t),g(D,e,t),i(e,Ke,t),i(e,J,t),i(e,Ze,t),i(e,R,t),i(e,et,t),i(e,z,t),i(e,tt,t),g(O,e,t),i(e,nt,t),i(e,N,t),i(e,it,t),i(e,X,t),i(e,lt,t),g(Y,e,t),i(e,st,t),i(e,Q,t),i(e,ot,t),i(e,V,t),i(e,at,t),g(K,e,t),i(e,rt,t),i(e,v,t),i(e,ut,t),i(e,Z,t),i(e,ft,t),i(e,ee,t),i(e,mt,t),i(e,te,t),i(e,gt,t),i(e,ne,t),i(e,ht,t),i(e,ie,t),i(e,pt,t),i(e,$,t),i(e,dt,t),g(le,e,t),i(e,ct,t),i(e,se,t),i(e,wt,t),i(e,oe,t),i(e,vt,t),i(e,y,t),i(e,$t,t),g(ae,e,t),i(e,yt,t),i(e,re,t),i(e,Tt,t),i(e,ue,t),i(e,bt,t),i(e,T,t),i(e,xt,t),g(fe,e,t),i(e,Lt,t),i(e,me,t),i(e,Ct,t),g(ge,e,t),i(e,Ht,t),i(e,he,t),i(e,_t,t),i(e,pe,t),i(e,Mt,t),g(de,e,t),i(e,Pt,t),i(e,ce,t),i(e,At,t),i(e,we,t),i(e,kt,t),g(ve,e,t),i(e,It,t),i(e,$e,t),i(e,jt,t),i(e,ye,t),i(e,qt,t),g(Te,e,t),i(e,Ut,t),i(e,be,t),i(e,Ft,t),i(e,xe,t),i(e,St,t),g(Le,e,t),i(e,Wt,t),i(e,Ce,t),i(e,Et,t),i(e,He,t),i(e,Bt,t),i(e,b,t),i(e,Gt,t),g(_e,e,t),i(e,Dt,t),i(e,Pe,t),Jt=!0},p:Dn,i(e){Jt||(h(x.$$.fragment,e),h(A.$$.fragment,e),h(S.$$.fragment,e),h(D.$$.fragment,e),h(O.$$.fragment,e),h(Y.$$.fragment,e),h(K.$$.fragment,e),h(le.$$.fragment,e),h(ae.$$.fragment,e),h(fe.$$.fragment,e),h(ge.$$.fragment,e),h(de.$$.fragment,e),h(ve.$$.fragment,e),h(Te.$$.fragment,e),h(Le.$$.fragment,e),h(_e.$$.fragment,e),Jt=!0)},o(e){p(x.$$.fragment,e),p(A.$$.fragment,e),p(S.$$.fragment,e),p(D.$$.fragment,e),p(O.$$.fragment,e),p(Y.$$.fragment,e),p(K.$$.fragment,e),p(le.$$.fragment,e),p(ae.$$.fragment,e),p(fe.$$.fragment,e),p(ge.$$.fragment,e),p(de.$$.fragment,e),p(ve.$$.fragment,e),p(Te.$$.fragment,e),p(Le.$$.fragment,e),p(_e.$$.fragment,e),Jt=!1},d(e){e&&(n(ke),n(Me),n(Ie),n(je),n(L),n(qe),n(C),n(Ue),n(H),n(Fe),n(_),n(Se),n(M),n(We),n(P),n(Ee),n(Be),n(k),n(Ge),n(I),n(De),n(j),n(Je),n(q),n(Re),n(U),n(ze),n(F),n(Oe),n(Ne),n(W),n(Xe),n(E),n(Ye),n(B),n(Qe),n(G),n(Ve),n(Ke),n(J),n(Ze),n(R),n(et),n(z),n(tt),n(nt),n(N),n(it),n(X),n(lt),n(st),n(Q),n(ot),n(V),n(at),n(rt),n(v),n(ut),n(Z),n(ft),n(ee),n(mt),n(te),n(gt),n(ne),n(ht),n(ie),n(pt),n($),n(dt),n(ct),n(se),n(wt),n(oe),n(vt),n(y),n($t),n(yt),n(re),n(Tt),n(ue),n(bt),n(T),n(xt),n(Lt),n(me),n(Ct),n(Ht),n(he),n(_t),n(pe),n(Mt),n(Pt),n(ce),n(At),n(we),n(kt),n(It),n($e),n(jt),n(ye),n(qt),n(Ut),n(be),n(Ft),n(xe),n(St),n(Wt),n(Ce),n(Et),n(He),n(Bt),n(b),n(Gt),n(Dt),n(Pe)),n(w),d(x,e),d(A,e),d(S,e),d(D,e),d(O,e),d(Y,e),d(K,e),d(le,e),d(ae,e),d(fe,e),d(ge,e),d(de,e),d(ve,e),d(Te,e),d(Le,e),d(_e,e)}}}const Qn='{"title":"Welcome to the 🤗 AI Agents Course","local":"introduction","sections":[{"title":"What to expect from this course?","local":"expect","sections":[],"depth":2},{"title":"What does the course look like?","local":"course-look-like","sections":[],"depth":2},{"title":"What’s the syllabus?","local":"syllabus","sections":[],"depth":2},{"title":"What are the prerequisites?","local":"what-are-the-prerequisites","sections":[],"depth":2},{"title":"What tools do I need?","local":"tools","sections":[],"depth":2},{"title":"The Certification Process","local":"certification-process","sections":[],"depth":2},{"title":"What is the recommended pace?","local":"recommended-pace","sections":[],"depth":2},{"title":"How to get the most out of the course?","local":"advice","sections":[],"depth":2},{"title":"Who are we","local":"who-are-we","sections":[{"title":"Joffrey Thomas","local":"joffrey-thomas","sections":[],"depth":3},{"title":"Ben Burtenshaw","local":"ben-burtenshaw","sections":[],"depth":3},{"title":"Thomas Simonini","local":"thomas-simonini","sections":[],"depth":3}],"depth":2},{"title":"I found a bug, or I want to improve the course","local":"contribute","sections":[],"depth":2},{"title":"I still have questions","local":"questions","sections":[],"depth":2}],"depth":1}';function Vn(Rt){return Jn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ni extends Rn{constructor(w){super(),zn(this,w,Vn,Yn,Gn,{})}}export{ni as component};
