import{s as Se,f as Zt,n as qe,o as ze}from"../chunks/scheduler.f6b352c8.js";import{S as De,i as Ne,g as l,s,r as p,m as Be,A as Ge,h as a,f as n,c as o,j as Re,u,x as r,n as Ue,k as c,y as je,a as i,v as d,d as m,t as g,w as f}from"../chunks/index.7f38e934.js";import{H as ot}from"../chunks/Heading.333929c4.js";import{E as Je}from"../chunks/EditOnGithub.c3245a01.js";function Fe(te){let h,rt,lt,ht,v,pt,b,ee="In the previous Unit, we saw <strong>how tools are made available to the agent in the system prompt</strong>.",ut,x,ne="Let’s now continue building the system message with some instructions for the Agent.",ct,T,dt,y,ie="We learned that AI agents are systems that can reason, plan, and interact with their environment. In this section, we will explore components conceptually and in the following sections we focus on implementing them.",mt,C,se="To grasp how agents function, imagine a continuous cycle of thinking, acting, and observing. Let’s break down these actions together :",gt,w,oe="<li><strong>Thought:</strong> The LLM in the agent decides what the next step should be</li> <li><strong>Action:</strong> The agent takes an action, by using the tools it wants to call with the associated arguments.</li> <li><strong>Observation:</strong> The agent reflects on the response from the tool.</li>",ft,$,vt,_,le="The three components work together in a continuous loop. To use an analogy from programming, the agent uses a <strong>while loop</strong>. The loop continues until the objective of the agent has been fulfilled.",bt,A,ae="Visually it looks like this:",xt,k,re,Tt,L,he="Just like tools, it may seem a bit deceiving but most agents actually only rely on prompting to have rules in place in the framework.",yt,M,pe="In an simplified version, our system prompt now looks like this:",Ct,P,ue,wt,H,ce="Let’s now break down each step of the process.",$t,I,_t,O,de="Thoughts represent the <strong>Agent’s internal reasoning and planning processes</strong>.",At,E,me="This utilises the agent’s Large Language Model (LLM) capacity to analyze information when presented in it’s prompt.",kt,R,ge="Think of it as the agent’s internal dialogue, where it considers the task at hand and strategizes its approach.",Lt,S,fe="The Agent’s thoughts are responsible for accessing current observations and decide what the next action(s) should be. Through this process, the agent can break down complex problems into smaller, more manageable steps, reflect on past experiences, and continuously adjust its plans based on new information.",Mt,q,ve="Here are some examples of common thoughts:",Pt,z,be="<thead><tr><th>Type of Thought</th> <th>Example</th></tr></thead> <tbody><tr><td>Planning</td> <td>“I need to break this task into three steps: 1) gather data, 2) analyze trends, 3) generate report”</td></tr> <tr><td>Analysis</td> <td>“Based on the error message, the issue appears to be with the database connection parameters”</td></tr> <tr><td>Decision Making</td> <td>“Given the user’s budget constraints, I should recommend the mid-tier option”</td></tr> <tr><td>Problem Solving</td> <td>“To optimize this code, I should first profile it to identify bottlenecks”</td></tr> <tr><td>Memory Integration</td> <td>“The user mentioned their preference for Python earlier, so I’ll provide examples in Python”</td></tr> <tr><td>Self-Reflection</td> <td>“My last approach didn’t work well, I should try a different strategy”</td></tr> <tr><td>Goal Setting</td> <td>“To complete this task, I need to first establish the acceptance criteria”</td></tr> <tr><td>Prioritization</td> <td>“The security vulnerability should be addressed before adding new features”</td></tr></tbody>",Ht,D,xe="<p><strong>Note:</strong> In the case of fine-tuned models for function-calling, the thought process is optional.<br/> <em>In case you’re not familiar with function-calling, there will be more detail in the Action section.</em></p>",It,N,Ot,B,Te=`This concept of thinking before Acting orginates from the ReAct prompt. ReAct is the concatenation of <strong>“Reasoning”</strong> and <strong>“Acting”</strong>.
ReAct is a simple prompting technique that appends “Let’s think step by step” before letting the LLM decode the next tokens.`,Et,G,ye,Rt,U,Ce=`Prompting the model to think “step by step” encourages the decoding process toward next tokens that generate a plan, rather than a final solution.
After “Let’s think step by step”, the model will <strong>decompose</strong> the problem into sub-tasks. This allows the model to consider sub-steps in more detail, which in general leads to less errors than directly generating solution.`,St,j,we="Recently we have seen an interest for reasoning. Models like Deepseek-R1 or OpenAI’s o1 have been fine-tuned to  “think before answering”.",qt,J,$e="<p>Note : Those model have been fine-tuned to always include specific thinking ( enclosed in &lt;think&gt;&lt;/think&gt; special token). This is not a purely prompting technique like ReAct</p>",zt,F,Dt,K,_e="Actions are the concrete steps an AI agent takes to interact with its environment. These can range from browsing the web for information to controlling a robot in a physical space. Consider an agent assisting with customer service - it might retrieve customer data, offer support articles, or escalate issues to human representatives.",Nt,Q,Ae="There is multiple types of Agents, that take actions differently:",Bt,W,ke="<thead><tr><th>Type of Agent</th> <th>Description</th></tr></thead> <tbody><tr><td>JSON Agent</td> <td>The Action to take is specified as in JSON format</td></tr> <tr><td>Code Agent</td> <td>The Agents writes a code bloc that is interpreted externally</td></tr> <tr><td>Function-calling Agent</td> <td>It is a subcategory of the JSON Agent which has been fine-tuned to generate a new message for each action</td></tr></tbody>",Gt,X,Le="We’ve only touched the surface on actions. In the <strong>Action</strong> section, we’ll give more information about each agent type.",Ut,V,Me="Here are some examples of possible Actions.",jt,Y,Pe="<thead><tr><th>Type of Action</th> <th>Description</th></tr></thead> <tbody><tr><td>Information Gathering</td> <td>Performing web searches, querying databases, retrieving documents</td></tr> <tr><td>Tool Usage</td> <td>Making API calls, running calculations, writing and executing code</td></tr> <tr><td>Environment Interaction</td> <td>Manipulating digital interfaces, controlling physical robots or devices</td></tr> <tr><td>Communication</td> <td>Engaging with users through chat, collaborating with other AI agents</td></tr></tbody>",Jt,Z,He=`One crucial part of an agent is the ability to <strong>STOP</strong> generating new tokens when an action is complete, and that is true for all formats of Agent; JSON, code, or function-calling.
The LLM only handles text, and uses it to describe the action it wants to take and the parameters to supply to the tool.`,Ft,tt,Kt,et,Ie="Observations are how an AI agent perceives the consequences of its actions. They provide crucial information that fuels the agent’s thought process and guides future actions. These observations can take many forms, from reading webpage text to monitoring a robot arm’s position. This can be seen like Tool “logs” that provide textual feedback of the Action execution.",Qt,nt,Oe="<thead><tr><th>Type of Observation</th> <th>Example</th></tr></thead> <tbody><tr><td>System Feedback</td> <td>Error messages, success notifications, status codes</td></tr> <tr><td>Data Changes</td> <td>Database updates, file system modifications, state changes</td></tr> <tr><td>Environmental Data</td> <td>Sensor readings, system metrics, resource usage</td></tr> <tr><td>Response Analysis</td> <td>API responses, query results, computation outputs</td></tr> <tr><td>Time-based Events</td> <td>Deadlines reached, scheduled tasks completed</td></tr></tbody>",Wt,it,Ee="Observation are added back into the prompt by the framework. This is why we need to stop generation of the next tokens when the model decides to take an action. If we don’t stop the generation, the LLM would hallucinate an Observation.",Xt,st,Vt,at,Yt;return v=new ot({props:{title:"Understanding AI Agents through the Thought-Action-Observation Cycle",local:"understanding-ai-agents-through-the-thought-action-observation-cycle",headingTag:"h1"}}),T=new ot({props:{title:"The Core Components",local:"the-core-components",headingTag:"h2"}}),$=new ot({props:{title:"The Thought-Action-Observation Cycle",local:"the-thought-action-observation-cycle",headingTag:"h2"}}),I=new ot({props:{title:"Thoughts",local:"thoughts",headingTag:"h3"}}),N=new ot({props:{title:"ReAct",local:"react",headingTag:"h4"}}),F=new ot({props:{title:"Actions",local:"actions",headingTag:"h3"}}),tt=new ot({props:{title:"Observations",local:"observations",headingTag:"h3"}}),st=new Je({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/agent-steps-and-structure.mdx"}}),{c(){h=l("meta"),rt=s(),lt=l("p"),ht=s(),p(v.$$.fragment),pt=s(),b=l("p"),b.innerHTML=ee,ut=s(),x=l("p"),x.textContent=ne,ct=s(),p(T.$$.fragment),dt=s(),y=l("p"),y.textContent=ie,mt=s(),C=l("p"),C.textContent=se,gt=s(),w=l("ol"),w.innerHTML=oe,ft=s(),p($.$$.fragment),vt=s(),_=l("p"),_.innerHTML=le,bt=s(),A=l("p"),A.textContent=ae,xt=s(),k=l("img"),Tt=s(),L=l("p"),L.textContent=he,yt=s(),M=l("p"),M.textContent=pe,Ct=s(),P=l("img"),wt=s(),H=l("p"),H.textContent=ce,$t=s(),p(I.$$.fragment),_t=s(),O=l("p"),O.innerHTML=de,At=s(),E=l("p"),E.textContent=me,kt=s(),R=l("p"),R.textContent=ge,Lt=s(),S=l("p"),S.textContent=fe,Mt=s(),q=l("p"),q.textContent=ve,Pt=s(),z=l("table"),z.innerHTML=be,Ht=s(),D=l("blockquote"),D.innerHTML=xe,It=s(),p(N.$$.fragment),Ot=s(),B=l("p"),B.innerHTML=Te,Et=s(),G=l("img"),Rt=s(),U=l("p"),U.innerHTML=Ce,St=s(),j=l("p"),j.textContent=we,qt=s(),J=l("blockquote"),J.innerHTML=$e,zt=s(),p(F.$$.fragment),Dt=s(),K=l("p"),K.textContent=_e,Nt=s(),Q=l("p"),Q.textContent=Ae,Bt=s(),W=l("table"),W.innerHTML=ke,Gt=s(),X=l("p"),X.innerHTML=Le,Ut=s(),V=l("p"),V.textContent=Me,jt=s(),Y=l("table"),Y.innerHTML=Pe,Jt=s(),Z=l("p"),Z.innerHTML=He,Ft=Be(`
<INSERT EXAMPLE>
`),p(tt.$$.fragment),Kt=s(),et=l("p"),et.textContent=Ie,Qt=s(),nt=l("table"),nt.innerHTML=Oe,Wt=s(),it=l("p"),it.textContent=Ee,Xt=s(),p(st.$$.fragment),Vt=s(),at=l("p"),this.h()},l(t){const e=Ge("svelte-u9bgzb",document.head);h=a(e,"META",{name:!0,content:!0}),e.forEach(n),rt=o(t),lt=a(t,"P",{}),Re(lt).forEach(n),ht=o(t),u(v.$$.fragment,t),pt=o(t),b=a(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-bl39my"&&(b.innerHTML=ee),ut=o(t),x=a(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-31xmxl"&&(x.textContent=ne),ct=o(t),u(T.$$.fragment,t),dt=o(t),y=a(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-x94o8i"&&(y.textContent=ie),mt=o(t),C=a(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-out94x"&&(C.textContent=se),gt=o(t),w=a(t,"OL",{"data-svelte-h":!0}),r(w)!=="svelte-1pf4l31"&&(w.innerHTML=oe),ft=o(t),u($.$$.fragment,t),vt=o(t),_=a(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1lhgzug"&&(_.innerHTML=le),bt=o(t),A=a(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-mx5c5b"&&(A.textContent=ae),xt=o(t),k=a(t,"IMG",{src:!0,alt:!0}),Tt=o(t),L=a(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1fdy1xc"&&(L.textContent=he),yt=o(t),M=a(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-yi1ahc"&&(M.textContent=pe),Ct=o(t),P=a(t,"IMG",{src:!0,alt:!0}),wt=o(t),H=a(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-e9clcw"&&(H.textContent=ce),$t=o(t),u(I.$$.fragment,t),_t=o(t),O=a(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-ns25ap"&&(O.innerHTML=de),At=o(t),E=a(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-231h29"&&(E.textContent=me),kt=o(t),R=a(t,"P",{"data-svelte-h":!0}),r(R)!=="svelte-qzqdp1"&&(R.textContent=ge),Lt=o(t),S=a(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-13olxph"&&(S.textContent=fe),Mt=o(t),q=a(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-ompwrf"&&(q.textContent=ve),Pt=o(t),z=a(t,"TABLE",{"data-svelte-h":!0}),r(z)!=="svelte-1efoj4x"&&(z.innerHTML=be),Ht=o(t),D=a(t,"BLOCKQUOTE",{"data-svelte-h":!0}),r(D)!=="svelte-1vjs3i5"&&(D.innerHTML=xe),It=o(t),u(N.$$.fragment,t),Ot=o(t),B=a(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-4lzv43"&&(B.innerHTML=Te),Et=o(t),G=a(t,"IMG",{src:!0,alt:!0}),Rt=o(t),U=a(t,"P",{"data-svelte-h":!0}),r(U)!=="svelte-mbuwi"&&(U.innerHTML=Ce),St=o(t),j=a(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1v4zp7l"&&(j.textContent=we),qt=o(t),J=a(t,"BLOCKQUOTE",{"data-svelte-h":!0}),r(J)!=="svelte-g3pulz"&&(J.innerHTML=$e),zt=o(t),u(F.$$.fragment,t),Dt=o(t),K=a(t,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1nt695k"&&(K.textContent=_e),Nt=o(t),Q=a(t,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-8xbx7z"&&(Q.textContent=Ae),Bt=o(t),W=a(t,"TABLE",{"data-svelte-h":!0}),r(W)!=="svelte-10vy6zf"&&(W.innerHTML=ke),Gt=o(t),X=a(t,"P",{"data-svelte-h":!0}),r(X)!=="svelte-apfbua"&&(X.innerHTML=Le),Ut=o(t),V=a(t,"P",{"data-svelte-h":!0}),r(V)!=="svelte-rbbf6e"&&(V.textContent=Me),jt=o(t),Y=a(t,"TABLE",{"data-svelte-h":!0}),r(Y)!=="svelte-1r66n6s"&&(Y.innerHTML=Pe),Jt=o(t),Z=a(t,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-vp6rc1"&&(Z.innerHTML=He),Ft=Ue(t,`
<INSERT EXAMPLE>
`),u(tt.$$.fragment,t),Kt=o(t),et=a(t,"P",{"data-svelte-h":!0}),r(et)!=="svelte-ixmcal"&&(et.textContent=Ie),Qt=o(t),nt=a(t,"TABLE",{"data-svelte-h":!0}),r(nt)!=="svelte-327b0l"&&(nt.innerHTML=Oe),Wt=o(t),it=a(t,"P",{"data-svelte-h":!0}),r(it)!=="svelte-52r6ss"&&(it.textContent=Ee),Xt=o(t),u(st.$$.fragment,t),Vt=o(t),at=a(t,"P",{}),Re(at).forEach(n),this.h()},h(){c(h,"name","hf:doc:metadata"),c(h,"content",Ke),Zt(k.src,re="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/Thought_Action_obs_cycle.gif")||c(k,"src",re),c(k,"alt","Think, Act, Observe cycle"),Zt(P.src,ue="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/system_prompt_cycle.png")||c(P,"src",ue),c(P,"alt","Think, Act, Observe cycle"),Zt(G.src,ye="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/ReAct.png")||c(G,"src",ye),c(G,"alt","ReAct")},m(t,e){je(document.head,h),i(t,rt,e),i(t,lt,e),i(t,ht,e),d(v,t,e),i(t,pt,e),i(t,b,e),i(t,ut,e),i(t,x,e),i(t,ct,e),d(T,t,e),i(t,dt,e),i(t,y,e),i(t,mt,e),i(t,C,e),i(t,gt,e),i(t,w,e),i(t,ft,e),d($,t,e),i(t,vt,e),i(t,_,e),i(t,bt,e),i(t,A,e),i(t,xt,e),i(t,k,e),i(t,Tt,e),i(t,L,e),i(t,yt,e),i(t,M,e),i(t,Ct,e),i(t,P,e),i(t,wt,e),i(t,H,e),i(t,$t,e),d(I,t,e),i(t,_t,e),i(t,O,e),i(t,At,e),i(t,E,e),i(t,kt,e),i(t,R,e),i(t,Lt,e),i(t,S,e),i(t,Mt,e),i(t,q,e),i(t,Pt,e),i(t,z,e),i(t,Ht,e),i(t,D,e),i(t,It,e),d(N,t,e),i(t,Ot,e),i(t,B,e),i(t,Et,e),i(t,G,e),i(t,Rt,e),i(t,U,e),i(t,St,e),i(t,j,e),i(t,qt,e),i(t,J,e),i(t,zt,e),d(F,t,e),i(t,Dt,e),i(t,K,e),i(t,Nt,e),i(t,Q,e),i(t,Bt,e),i(t,W,e),i(t,Gt,e),i(t,X,e),i(t,Ut,e),i(t,V,e),i(t,jt,e),i(t,Y,e),i(t,Jt,e),i(t,Z,e),i(t,Ft,e),d(tt,t,e),i(t,Kt,e),i(t,et,e),i(t,Qt,e),i(t,nt,e),i(t,Wt,e),i(t,it,e),i(t,Xt,e),d(st,t,e),i(t,Vt,e),i(t,at,e),Yt=!0},p:qe,i(t){Yt||(m(v.$$.fragment,t),m(T.$$.fragment,t),m($.$$.fragment,t),m(I.$$.fragment,t),m(N.$$.fragment,t),m(F.$$.fragment,t),m(tt.$$.fragment,t),m(st.$$.fragment,t),Yt=!0)},o(t){g(v.$$.fragment,t),g(T.$$.fragment,t),g($.$$.fragment,t),g(I.$$.fragment,t),g(N.$$.fragment,t),g(F.$$.fragment,t),g(tt.$$.fragment,t),g(st.$$.fragment,t),Yt=!1},d(t){t&&(n(rt),n(lt),n(ht),n(pt),n(b),n(ut),n(x),n(ct),n(dt),n(y),n(mt),n(C),n(gt),n(w),n(ft),n(vt),n(_),n(bt),n(A),n(xt),n(k),n(Tt),n(L),n(yt),n(M),n(Ct),n(P),n(wt),n(H),n($t),n(_t),n(O),n(At),n(E),n(kt),n(R),n(Lt),n(S),n(Mt),n(q),n(Pt),n(z),n(Ht),n(D),n(It),n(Ot),n(B),n(Et),n(G),n(Rt),n(U),n(St),n(j),n(qt),n(J),n(zt),n(Dt),n(K),n(Nt),n(Q),n(Bt),n(W),n(Gt),n(X),n(Ut),n(V),n(jt),n(Y),n(Jt),n(Z),n(Ft),n(Kt),n(et),n(Qt),n(nt),n(Wt),n(it),n(Xt),n(Vt),n(at)),n(h),f(v,t),f(T,t),f($,t),f(I,t),f(N,t),f(F,t),f(tt,t),f(st,t)}}}const Ke='{"title":"Understanding AI Agents through the Thought-Action-Observation Cycle","local":"understanding-ai-agents-through-the-thought-action-observation-cycle","sections":[{"title":"The Core Components","local":"the-core-components","sections":[],"depth":2},{"title":"The Thought-Action-Observation Cycle","local":"the-thought-action-observation-cycle","sections":[{"title":"Thoughts","local":"thoughts","sections":[{"title":"ReAct","local":"react","sections":[],"depth":4}],"depth":3},{"title":"Actions","local":"actions","sections":[],"depth":3},{"title":"Observations","local":"observations","sections":[],"depth":3}],"depth":2}],"depth":1}';function Qe(te){return ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ze extends De{constructor(h){super(),Ne(this,h,Qe,Fe,Se,{})}}export{Ze as component};
